#include <npapi.h>
#include <npupp.h>

#define PLUGIN_NAME "GtkSocket test plugin"
#define PLUGIN_DESC "Test Firefox GtkSocket support"
#define PLUGIN_MIME_DESC "application/x-gtksocket:gtksocket:GtkSocket;"
#define PLUGIN_MIME_TYPE "application/x-gtksocket"
#define PLUGIN_FILE_EXTS "gtksocket"
#define PLUGIN_MIME_COUNT 1

NPError
GtkSocket_New (NPMIMEType pluginType, NPP instance, uint16 mode,
               int16 argc, char* argn[], char* argv[],
               NPSavedData* saved)
{
  return NPERR_NO_ERROR;
}

NPError
GtkSocket_GetValue (NPP instance, NPPVariable variable, void* value)
{
  PRBool* bool_value = (PRBool*) value;

  switch (variable)
    {
    case NPPVpluginNeedsXEmbed:
      *bool_value = PR_TRUE;
      break;

    default:
      break;
    }

  return NPERR_NO_ERROR;
}

NPError
GtkSocket_Destroy (NPP instance, NPSavedData** save)
{
  return NPERR_NO_ERROR;
}

NPError
GtkSocket_SetWindow (NPP instance, NPWindow* window)
{
  return NPERR_NO_ERROR;
}

NPError
GtkSocket_NewStream (NPP instance, NPMIMEType type, NPStream* stream,
                     NPBool seekable, uint16* stype)
{
  return NPERR_NO_ERROR;
}

void
GtkSocket_StreamAsFile (NPP instance, NPStream* stream, const char* filename)
{
}

NPError
GtkSocket_DestroyStream (NPP instance, NPStream* stream, NPReason reason)
{
  return NPERR_NO_ERROR;
}

int32
GtkSocket_WriteReady (NPP instance, NPStream* stream)
{
  return 0;
}

int32
GtkSocket_Write (NPP instance, NPStream* stream, int32 offset, int32 len,
           void* buffer)
{
  return 0;
}

void
GtkSocket_Print (NPP instance, NPPrint* platformPrint)
{
}

int16
GtkSocket_HandleEvent (NPP instance, void* event)
{
  return 0;
}

void
GtkSocket_URLNotify (NPP instance, const char* url, NPReason reason,
               void* notifyData)
{
}

jref
GtkSocket_GetJavaClass (void)
{
  return 0;
}

NPError
NP_Initialize (NPNetscapeFuncs* browserTable, NPPluginFuncs* pluginTable)
{
  pluginTable->version = (NP_VERSION_MAJOR << 8) + NP_VERSION_MINOR;
  pluginTable->size = sizeof (NPPluginFuncs);
  pluginTable->newp = NewNPP_NewProc (GtkSocket_New);
  pluginTable->destroy = NewNPP_DestroyProc (GtkSocket_Destroy);
  pluginTable->setwindow = NewNPP_SetWindowProc (GtkSocket_SetWindow);
  pluginTable->newstream = NewNPP_NewStreamProc (GtkSocket_NewStream);
  pluginTable->destroystream = NewNPP_DestroyStreamProc (GtkSocket_DestroyStream);
  pluginTable->asfile = NewNPP_StreamAsFileProc (GtkSocket_StreamAsFile);
  pluginTable->writeready = NewNPP_WriteReadyProc (GtkSocket_WriteReady);
  pluginTable->write = NewNPP_WriteProc (GtkSocket_Write);
  pluginTable->print = NewNPP_PrintProc (GtkSocket_Print);
  pluginTable->urlnotify = NewNPP_URLNotifyProc (GtkSocket_URLNotify);
  pluginTable->getvalue = NewNPP_GetValueProc (GtkSocket_GetValue);

  return NPERR_NO_ERROR;
}

char*
NP_GetMIMEDescription (void)
{
  return (char*) PLUGIN_MIME_DESC;
}

NPError
NP_GetValue (void* future, NPPVariable variable, void* value)
{
  char** char_value = (char**) value;

  switch (variable)
    {
    case NPPVpluginNameString:
      *char_value = (char*) PLUGIN_NAME;
      break;

    case NPPVpluginDescriptionString:
      *char_value = (char*) PLUGIN_DESC;
      break;

    default:
      break;
    }

  return NPERR_NO_ERROR;
}

NPError
NP_Shutdown (void)
{
  return NPERR_NO_ERROR;
}
